/*******************************************************************************
****BoardZio DC-DC Booster
****VersionV1.0
****AuthorHarry
****Data:5-9-2018
*******************************************************************************/

#include "stm8l15x.h"

char HexTable[]={0x80,0xF2,0x48,0x60,0x32,0x24,0x04,0xF0,0x00,0x30};

uint16_t u16_adc1_value=0;
uint16_t Nadc=0;
float VDD_value=0;
uint16_t VoltageValue=0;
uint16_t VoltageValue_in=0;
uint16_t VoltageValue_out=0;
extern uint16_t Flag_Display=0;
extern uint16_t Flag_On=0;

void GPIO_Config()
{
  GPIO_Init(GPIOA, (GPIO_Pin_TypeDef) GPIO_Pin_2, GPIO_Mode_In_FL_IT);
  GPIO_Init(GPIOA, (GPIO_Pin_TypeDef) GPIO_Pin_3, GPIO_Mode_In_FL_IT);
  GPIO_Init(GPIOB, (GPIO_Pin_TypeDef)GPIO_Pin_1,GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOB, (GPIO_Pin_TypeDef)GPIO_Pin_2,GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOB, (GPIO_Pin_TypeDef)GPIO_Pin_3,GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOB, (GPIO_Pin_TypeDef)GPIO_Pin_4,GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOB, (GPIO_Pin_TypeDef)GPIO_Pin_5,GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOB, (GPIO_Pin_TypeDef)GPIO_Pin_6,GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOB, (GPIO_Pin_TypeDef)GPIO_Pin_7,GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOC, (GPIO_Pin_TypeDef)GPIO_Pin_0 | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6,GPIO_Mode_Out_PP_Low_Fast);
  GPIO_Init(GPIOB, (GPIO_Pin_TypeDef)GPIO_Pin_0, GPIO_Mode_In_FL_No_IT);
  GPIO_Init(GPIOD, (GPIO_Pin_TypeDef)GPIO_Pin_0, GPIO_Mode_In_FL_No_IT);
  GPIO_Init(GPIOC, (GPIO_Pin_TypeDef)GPIO_Pin_1, GPIO_Mode_Out_PP_Low_Fast);

  GPIO_ResetBits(GPIOC,GPIO_Pin_1);
  
}

void delay(uint16_t Z)
{
  uint16_t i,j;
  for(i=0;i<Z;i++)
    for(j=0;j<500;j++);
      
}

/*******************************************************************************
*******Inlet parameters:None
*******Export parameters:None
*******Functionmain
*******************************************************************************/
void main( void )
{
    uint16_t n=0;
    uint16_t VoltageValue_In_Sum=0;
    uint16_t VoltageValue_Out_Sum=0;

    CLK_SYSCLKDivConfig(CLK_SYSCLKDiv_1);    //1ƵƵ 
    CLK_SYSCLKSourceConfig(CLK_SYSCLKSource_HSI);//лΪڲʱ
    CLK_HSICmd(ENABLE);                      //ʹڲʱ

     GPIO_Config();
     EXTI_DeInit (); //ָжϵ 
     EXTI_SetPinSensitivity (EXTI_Pin_2,EXTI_Trigger_Falling);//ⲿж2½ش
     EXTI_SetPinSensitivity (EXTI_Pin_3,EXTI_Trigger_Falling);//ⲿж3½ش
     

     ADC_Cmd(ADC1,ENABLE);
     CLK_PeripheralClockConfig (CLK_Peripheral_ADC1,ENABLE);//ADCʱ

     ADC_Init (ADC1,ADC_ConversionMode_Single,ADC_Resolution_12Bit,ADC_Prescaler_1);
     ADC_SamplingTimeConfig(ADC1,ADC_Group_SlowChannels,ADC_SamplingTime_384Cycles);
     ADC_SchmittTriggerConfig(ADC1,ADC_Channel_22,DISABLE);
     ADC_SchmittTriggerConfig(ADC1,ADC_Channel_18,DISABLE);
 
     
     ADC_VrefintCmd(ENABLE);
     ADC_Cmd(ADC1,ENABLE);
     enableInterrupts();
     
     
     
     while(1)
     { 
        
       
       if(Flag_On>199)
        {Flag_On=0;}
       if(Flag_On%2)
        {GPIO_SetBits(GPIOC,GPIO_Pin_1);}
       else
        {GPIO_ResetBits(GPIOC,GPIO_Pin_1);}
       
       ADC_ChannelCmd(ADC1, ADC_Channel_Vrefint,ENABLE);//ѡڲ׼ͨ
       ADC_SoftwareStartConv(ADC1); //ת
       while(!ADC_GetFlagStatus(ADC1,ADC_FLAG_EOC));//ȴת
       ADC_ClearFlag(ADC1,ADC_FLAG_EOC);//Ӧ־
       Nadc=ADC_GetConversionValue(ADC1); //ȡתֵ
       VDD_value=123*4096UL/Nadc; //VDDѹλV
       ADC_ChannelCmd(ADC1, ADC_Channel_Vrefint,DISABLE);//ʧڲ׼ͨ

       for(VoltageValue_In_Sum=0,n=0;n<8;n++)
       {
       ADC_ChannelCmd (ADC1,ADC_Channel_22,ENABLE);
       ADC_SoftwareStartConv (ADC1);
       while(!ADC_GetFlagStatus (ADC1,ADC_FLAG_EOC));
       ADC_ClearFlag (ADC1,ADC_FLAG_EOC);
       u16_adc1_value=ADC_GetConversionValue (ADC1);

       VoltageValue_in=400*1.23*u16_adc1_value/Nadc;
       ADC_ChannelCmd (ADC1,ADC_Channel_22,DISABLE);
       VoltageValue_In_Sum=VoltageValue_In_Sum+VoltageValue_in;
       }
     
       for(VoltageValue_Out_Sum=0,n=0;n<8;n++)
       {
       ADC_ChannelCmd (ADC1,ADC_Channel_18,ENABLE);
       ADC_SoftwareStartConv (ADC1);
       while(!ADC_GetFlagStatus (ADC1,ADC_FLAG_EOC));
       ADC_ClearFlag (ADC1,ADC_FLAG_EOC);
       u16_adc1_value=ADC_GetConversionValue (ADC1);

       VoltageValue_out=1100*1.23*u16_adc1_value/Nadc;
       ADC_ChannelCmd (ADC1,ADC_Channel_18,DISABLE);
       VoltageValue_Out_Sum=VoltageValue_Out_Sum+VoltageValue_out;
       }
      
       if(Flag_Display>199)
           Flag_Display=0;
       if(Flag_Display%2) VoltageValue=VoltageValue_In_Sum/8;
       else if(!(Flag_Display%2) && !(Flag_On%2)) VoltageValue=0;
       else 
         VoltageValue=VoltageValue_Out_Sum/8;
       
       if(VoltageValue<1000)
       {

       GPIOB->ODR = HexTable[VoltageValue/100];
       GPIO_SetBits(GPIOC,GPIO_Pin_4);
       GPIO_ResetBits(GPIOC,GPIO_Pin_5);
       GPIO_SetBits(GPIOC,GPIO_Pin_6);   
       GPIO_ResetBits(GPIOC,GPIO_Pin_0);
       delay(50);
       GPIO_SetBits(GPIOC,GPIO_Pin_4);
       GPIOB->ODR = HexTable[VoltageValue%100/10];
       GPIO_SetBits(GPIOC,GPIO_Pin_4);
       GPIO_SetBits(GPIOC,GPIO_Pin_5);
       GPIO_ResetBits(GPIOC,GPIO_Pin_6);   
       GPIO_SetBits(GPIOC,GPIO_Pin_0);

       delay(40);
       GPIO_SetBits(GPIOC,GPIO_Pin_6);
       }
       else
         {

       GPIOB->ODR = HexTable[VoltageValue/1000];
       GPIO_ResetBits(GPIOC,GPIO_Pin_4);
       GPIO_SetBits(GPIOC,GPIO_Pin_5);
       GPIO_SetBits(GPIOC,GPIO_Pin_6);   
       GPIO_SetBits(GPIOC,GPIO_Pin_0);
       delay(50);
       GPIO_SetBits(GPIOC,GPIO_Pin_4);
       GPIOB->ODR = HexTable[VoltageValue%1000/100];
       GPIO_SetBits(GPIOC,GPIO_Pin_4);
       GPIO_ResetBits(GPIOC,GPIO_Pin_5);
       GPIO_SetBits(GPIOC,GPIO_Pin_6);   
       GPIO_ResetBits(GPIOC,GPIO_Pin_0);
       delay(50);
       GPIO_SetBits(GPIOC,GPIO_Pin_5);
       GPIOB->ODR = HexTable[VoltageValue%100/10];
       GPIO_SetBits(GPIOC,GPIO_Pin_4);
       GPIO_SetBits(GPIOC,GPIO_Pin_5);
       GPIO_ResetBits(GPIOC,GPIO_Pin_6);   
       GPIO_SetBits(GPIOC,GPIO_Pin_0);

       delay(40);
       GPIO_SetBits(GPIOC,GPIO_Pin_6);
       }

     }
}
 
/*******************************************************************************
******************************Zio DC-DC Booster*********************************
**************************www.smart-prototyping.com*****************************
*******************************************************************************/
